<!DOCTYPE html>
<html>

<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

    <title>Babylon.js Demo</title>

    <!-- Babylon.js -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/dat-gui/0.6.2/dat.gui.min.js"></script>
    <script src="https://preview.babylonjs.com/ammo.js"></script>
    <script src="https://preview.babylonjs.com/cannon.js"></script>
    <script src="https://preview.babylonjs.com/Oimo.js"></script>
    <script src="https://preview.babylonjs.com/earcut.min.js"></script>
    <script src="https://preview.babylonjs.com/babylon.js"></script>
    <script src="https://preview.babylonjs.com/materialsLibrary/babylonjs.materials.min.js"></script>
    <script src="https://preview.babylonjs.com/proceduralTexturesLibrary/babylonjs.proceduralTextures.min.js"></script>
    <script src="https://preview.babylonjs.com/postProcessesLibrary/babylonjs.postProcess.min.js"></script>
    <script src="https://preview.babylonjs.com/loaders/babylonjs.loaders.js"></script>
    <script src="https://preview.babylonjs.com/serializers/babylonjs.serializers.min.js"></script>
    <script src="https://preview.babylonjs.com/gui/babylon.gui.min.js"></script>
    <script src="https://preview.babylonjs.com/inspector/babylon.inspector.bundle.js"></script>

    <style>
        html,
        body {
            overflow: hidden;
            width: 100%;
            height: 100%;
            margin: 0;
            padding: 0;
        }

        #renderCanvas {
            width: 100%;
            height: 100%;
            touch-action: none;
        }
    </style>
</head>

<body>
    <canvas id="renderCanvas"></canvas>
    <script>
        //Variabelen

        var canvas = document.getElementById("renderCanvas");
        var engine = null;
        var scene = null;
        var sceneToRender = null;
        var createDefaultEngine = function () {
            return new BABYLON.Engine(canvas, true, {
                preserveDrawingBuffer: true,
                stencil: true,
                disableWebGL2Support: false
            });
        };

        var delayCreateScene = function () {
            // Scene maken
            var scene = new BABYLON.Scene(engine);
            var camera = new BABYLON.FreeCamera("camera1", new BABYLON.Vector3(0, 20, -10), scene);

            // Muiswiel gebruiken
            camera.inputs.addMouseWheel();

            // Camera wijzen naar het eerste geladen object
            camera.setTarget(BABYLON.Vector3.Zero());
            camera.attachControl(true);

            //Licht maken
            const light = new BABYLON.HemisphericLight("light", new BABYLON.Vector3(1, 1, 0));

            //Met meshBuilder een vloer maken
            const ground = BABYLON.MeshBuilder.CreateGround("ground", {
                width: 50,
                height: 50
            });


            // Skybox inladen
            var hdrTexture = BABYLON.CubeTexture.CreateFromPrefilteredData("textures/environment.dds", scene);
            var currentSkybox = scene.createDefaultSkybox(hdrTexture, true);

            // Alle modellen inladen
            BABYLON.SceneLoader.Append("textures/", "running.glb", scene);
            BABYLON.SceneLoader.Append("textures/", "standing.glb", scene);
            BABYLON.SceneLoader.Append("textures/", "falling.glb", scene);
            BABYLON.SceneLoader.Append("textures/", "jumping.glb", scene);
            BABYLON.SceneLoader.Append("textures/", "JapaneseGatesTorii_OBJ.obj", scene);
        
            //Muziek inladen
            var music = new BABYLON.Sound("squidgame", "sounds/squidgame.mp3", scene,
                null, {
                    loop: true,
                    autoplay: true,
                    spatialSound: true,
                    maxDistance: 100
                });
            //positie zetten voor spatialSound in onze wereld
            music.setPosition(new BABYLON.Vector3(60, 0, 0));
            return scene;
        };

        //Engine laten runnen
        window.initFunction = async function () {


            var asyncEngineCreation = async function () {
                try {
                    return createDefaultEngine();
                } catch (e) {
                    console.log(
                        "the available createEngine function failed. Creating the default engine instead"
                    );
                    return createDefaultEngine();
                }
            }

            window.engine = await asyncEngineCreation();
            if (!engine) throw 'engine should not be null.';
            window.scene = delayCreateScene();
        };
        initFunction().then(() => {
            sceneToRender = scene
            engine.runRenderLoop(function () {
                if (sceneToRender && sceneToRender.activeCamera) {
                    sceneToRender.render();
                }
            });
        });

        // Resizing
        window.addEventListener("resize", function () {
            engine.resize();
        });
    </script>
</body>

</html>